#!/usr/bin/bash

# data_graph.sh -- make a dependencies list of global symbols for dot

# ----------------------------------------------------------------
# This file is part of code_graphs Copyright (C) 2011 Elijah 
# Laboratories Inc.  http://www.elilabs.com  ALL RIGHTS RESERVED.
#
# GNU cflow is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 3 of the License, or (at your
# option) any later version.
#
# code_graphs is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with code_graphs; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
# ----------------------------------------------------------------


./list_defs.sh *.o > defs.dat
./list_undefs.sh *.o > undefs.dat

cat defs.dat undefs.dat | awk '{ print $2 }' - | sort -u > syms.dat
cat defs.dat undefs.dat | awk '{ print $1 }' - | sort -u > modules.dat

awk -v dq='"' '{ print dq $1 dq,"->",dq $2 dq ";" }' defs.dat > dep.dot
awk -v dq='"' '{ print dq $2 dq,"->",dq $1 dq ";" }' undefs.dat >> dep.dot

awk -v dq='"' '{ print dq $1 dq,"[shape=rectangle,style=filled,fillcolor=green,href=" dq  $1 ".pdf" dq "];" }' syms.dat > dep.sty
awk -v dq='"' '{ print dq $1 dq,"[style=filled,fillcolor=yellow,href=" dq  $1 ".pdf" dq "];" }' modules.dat >> dep.sty


# generate the pdf file for the graph
make -f dot_makefile clean
make -f dot_makefile

# put the result in the right place
cp dep.pdf '==ALL==.pdf'

# generate all of its subgraphs
./clickable_subgraphs.sh

# now make the table of contents
./dir.sh > dir.html

# put in final home
mkdir -p call_graph
cp *.html *.pdf call_graph/

