#!/usr/bin/bash

# package.sh -- make a tar file with all the files needed to drive the browser

# ----------------------------------------------------------------
# This file is part of code_graphs Copyright (C) 2011 Elijah 
# Laboratories Inc.  http://www.elilabs.com  ALL RIGHTS RESERVED.
#
# GNU cflow is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 3 of the License, or (at your
# option) any later version.
#
# code_graphs is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with code_graphs; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
# ----------------------------------------------------------------


# This script generates the file "package.tar.gz" which contains all
# the files needed to drive the browser, but none of the files used to
# generate those files.  It is intended to be placed in a directory of
# a web server so that user can access it over the internet/intranet,
# or so that users can download it and un-tar it for viewing on their
# local machine.


echo '---------------- make the package.tar.gz distribution tarball ----------------'

# start with a clean slate
rm -rf package
mkdir -p package

# fetch the top level files
cp *.html *.gif package/

# make the subdirectories we need and populate them
for d in module_graph extern_graph call_graph include_graph 
do mkdir package/$d
   cp $d/*.html $d/*.gif $d/*.pdf package/$d/
done

for d in listings
do mkdir package/$d
   cp $d/*.html package/$d/
done

# wrap it all up in a tarball
tar czf package.tar.gz package

