#!/usr/bin/bash

# stack_frames.sh -- Determine the stack frame size for each function.

# ----------------------------------------------------------------
# This file is part of code_graphs Copyright (C) 2011 Elijah 
# Laboratories Inc.  http://www.elilabs.com  ALL RIGHTS RESERVED.
#
# GNU cflow is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 3 of the License, or (at your
# option) any later version.
#
# code_graphs is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with code_graphs; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
# ----------------------------------------------------------------


# NOTE: This script is for gcc amd_64 linux *ONLY* !!!
#       It needs additional testing and manual verification.
#       It has been tested with gcc (Gentoo 4.4.5 p1.2, pie-0.4.5) 4.4.5
#       and with -O0, -O1, and -O2 optimization only.

# This script takes a set of *.lst gnu assembler listing files and
# outputs a file with the function name, module name, and the stack
# frame size in bytes on each line.

for f in *.lst
do awk -v f=`basename $f .lst` -v dq='"' \
  'flag == 0 && $4 == "@function"                                             { fcn = 1 ; names = dq substr($3,1,length($3)-1) dq " " f ; ofs = 0 ; next }
   NF == 3 && /\*\*\*\*\ \}/ && $3 == "}" && substr($1,length($1)-1) != ".h"  { flag = 2 }
   flag == 2 && $2 == ".loc"                                                  { flag = 1 ; next }
   flag == 1 && $4 == "addq"                                                  { ofs = 0+substr($5,2) ; next }
   flag == 1 && $4 == "popq"                                                  { ofs += 8 ; next }
   flag == 1 && $4 == "leave"                                                 { ofs += 8 ; next }
   flag == 1 && NR >=lin+2 && $4 == "ret"                                     { ofs += 8 ; next }
   flag == 0 && $2 == ".cfi_endproc" && fcn == 1                              { print names,"0" ; fcn = 0 ; ofs = 0 ; flag = 0 ; next}
   flag == 1 && $2 == ".cfi_endproc" && fcn == 1                              { print names,ofs ; fcn = 0 ; ofs = 0 ; flag = 0 ; next}' $f
done \
 | sort -u

