#!/bin/bash

# tarjan.sh -- wrapper script for tarjan.pl

# ----------------------------------------------------------------
# This file is part of code_graphs Copyright (C) 2011 Elijah 
# Laboratories Inc.  http://www.elilabs.com  ALL RIGHTS RESERVED.
#
# GNU cflow is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 3 of the License, or (at your
# option) any later version.
#
# code_graphs is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with code_graphs; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
# ----------------------------------------------------------------


# Inputs a *.dot file on stdin, outputs each SCC on a separate line.

cat - > tarjan.sh.1

cat tarjan.sh.1 \
 | grep -v '^#' \
 | ./tarjan.pl \
 | sort -n \
 | awk '$1 == prev_no && prev_no != "" { printf("%s ",prev_name) }
        $1 != prev_no                  { print prev_name }
                                       { prev_no = $1 ; prev_name = $2 }' - \
 | awk 'NF > 1 { print $0 }' -

cat tarjan.sh.1 | awk '$2 == "->" && $1 == $3 { print $1 }' -

